<?php
/*
* safe BB code
* Version: 1.6.2
*
* Info: readme.txt
*/

class sBBcode{
 /*
 * Variables
 */
 var $replace=array();
 var $search=array();
 var $lock_chars="([^\"'\(\)\%\;\=]*)";
 var $normal_tag_chars="([^\"']*)";
 var $normal_chars="(.*)";
 var $imgcode=0;
 var $maximages=2;
 var $usedimages=0;
 var $time=0;

 /*
 * this function compile the bbcode and exute the other
 * functions that compiles every tags.
 */
 function parsen($text){
  $this->usedimages=0;
  $text=preg_replace($this->search,$this->replace,$text);
  return $text;
 }

 /*
 * this function get the bbcode source file
 */
 function get($file){
  $this->time=time();
  include $file;
  return;
 }
  
 /*
 * this function compiles the regulary expressions,
 * that used in the other files
 */
 function new_tag($search,$replace,$params=0,$ende=0,$interlace=0,$secure=0,$tagsecure=1,$php=0,$pparser=0){
  if($pparser==1) $replace=$this->param_parser($replace,$params);
  
  if($php==1) $options='siUe';
  else $options='siU';
  
  if($tagsecure==1) $tagchars=&$this->lock_chars;
  else $tagchars=&$this->normal_tag_chars;
  
  if($params==0) $rex='\['.$search.']';
  elseif($params==1) $rex='\['.$search."=(['\"]?)".$tagchars.'\1]';
  else $rex='\['.$search."=(['\"]?)".$tagchars.str_repeat(','.$tagchars,$params-1).'\1]';
  
  if($ende==1){
   if($secure==1) $rex='/'.$rex.$this->lock_chars.'\[\/'.$search.'\]/'.$options;
   else $rex='/'.$rex.$this->normal_chars.'\[\/'.$search.'\]/'.$options;
  }else $rex='/'.$rex.'/'.$options;
  $i=-1;
  while($interlace>$i){
   $this->search[]=$rex;
   $this->replace[]=$replace;
   ++$i;
  }
  return;
 }
  
 /*
 * this function search for the url and email tag syntax and
 * add the tags for it
 */
 function url_parse($text){
  $text=preg_replace(
   array(
    "/([_a-zA-Z0-9-]+@+[a-zA-Z0-9-]+\.+([a-zA-Z]{2,4}))/si",
    "/(([^]_a-z0-9-=\"'\/])www\.([a-zA-Z0-9_\-.\/]{2,}))/si",
    "/(([^]_a-z0-9-=\"'\/])+(([a-zA-Z]{2,6}):\/\/)+([a-zA-Z0-9_\-.\/]{2,}))/si"),
   array('[email]\1[/email]','http://\1','[url]\1[/url]'),$text);
  return $text;
 }
 
 /*
 * the function listcode() compile the list tags
 */
 function listcode($text,$type=""){
  $text=str_replace("[*]","<li>",stripslashes($text));
  if($type=="num") return '<ol>'.$text.'</li></ol>';
  else return '<ul>'.$text.'</li></ul>';
 }
 
 /*
 * the function compile thie [php] tags
 */
 function phpcode($text){
  $text=stripslashes($text);
  $text=str_replace('&lt;','<',$text);
  $text=str_replace('&gt;','>',$text);
  $text=str_replace('&quot;','"',$text);
  $text=str_replace('&amp;','&',$text);
  $text=str_replace("<br />","",$text);
  
  if(!strstr($text,'<?')){
   $tag=1;
   $text="<?php /*".$this->time."*/".$text;
  }else $tag=0;

  ob_start();
  highlight_string($text);
  $text=ob_get_contents();
  ob_end_clean();

  if($tag==1){
   $text=str_replace("&lt;?php","",$text);
   $text=str_replace("/*".$this->time."*/","",$text);
  }
  $text=str_replace("}","&#125;",$text);
  $text=str_replace("{","&#123;",$text);
  $text=str_replace("<code>","",$text);
  $text=str_replace("</code>","",$text);
  return '<blockquote><font size=2>PHP:<hr>'.$text.'</font><hr></blockquote>';
 }
 
 /*
 * this function compile the [table] tag and
 * exute the trcode() function for every new line new line
 */
 function tablecode($text,$bgcolor="",$width=100,$align="",$border=1){
  $text=preg_replace(
   array("/\[tr=([\"\']?)".$this->lock_chars."\\1](.*)\[\/tr\]/esiU","/\[tr](.*)\[\/tr\]/esiU"),
   array("\$this->trcode('\\3','\\2')","\$this->trcode('\\1')"),stripslashes($text));
  return '<table cellspacing=0 cellpadding=0 border='.$border.' bgcolor="'.$bgcolor.'" width="'.$width.'%" align='.$align.'>'.$text.'</table>';
 }
 
 /*
 * this function is exuting by the tablecode function,
 * it create a new line and returns the html code
 */
 function trcode(&$text,$bgcolor=""){
  $text=preg_replace(
   array("/\[td=(([\"\']?)".$this->lock_chars.",".$this->lock_chars.")\\2](.*)\[\/td\]/siU","/\[td=([\"\']?)".$this->lock_chars."\\1](.*)\[\/td\]/si","/\[td](.*)\[\/td\]/siU"),
   array('<td bgcolor=\3 align=\4>\5</td>','<td bgcolor=\2>\3</td>','<td>\1</td>'),$text);
  return '<tr bgcolor=$bgcolor>'.$text.'</tr>';
 }
 
 /*
 * this function compile the [img] tag
 */
 function imgcode($imgurl,$comment=""){
  if(!$comment) $comment=&$imgurl;
  if($this->imgcode==0||$this->maximages<$this->usedimages) return "<a href=\"".$imgurl."\" target=_blank>".$comment."</a>";
  else{
   ++$this->usedimages;
   return '<img src="'.$imgurl.'" alt="'.$comment.'">';
  }
 }

 /*
 * this function replaces param values
 * like {param1} to the rex functions
 */
 function param_parser(&$text,&$parameter){
  $text=str_replace("{text}","\\\\".($parameter+1),$text);
  if($parameter>0) $param=3;
  else $param=1;
  $id=0;
  while($parameter>$id){
   $text=str_replace('{param'.$id.'}','\\\\'.$param,$text);
   ++$param;
   ++$id;
  }
  return $text;
 }
}

/*
* with this function you can use the class without
* known of the class stucture or oop programming
*/
function sBBcode($text,$imgcode=1,$urlparsing=1,$maximgs=2){
	global $relativer_pfad;
 static $sBBcode;
 if(!isset($sBBcode)){
  $sBBcode=new sBBcode;
  $sBBcode->imgcode=intval($imgcode);
  $sBBcode->maximgs=intval($maximgs);
  $sBBcode->get("$relativer_pfad/sbbcode/sBB_code.php");
 }
 if($urlparsing) $text=$sBBcode->url_parse($text);
 return $sBBcode->parsen(htmlentities($text));
}
?>
